using System;
using System.Collections.Generic;
using System.Net;
using System.Collections;

using EndCaptcha;
using System.Web;


namespace EndCaptcha
{
    public class Examples
    {

        static public void Main(string[] argv)
        {

            // Text Captcha Sample
            // EndCaptcha.Examples.TextCaptchaSample(argv);

            // ReCaptcha V2 Sample
            // EndCaptcha.Examples.ReCaptchaV2Sample(argv);

            // ReCaptcha V3 Sample
            // EndCaptcha.Examples.ReCaptchaV3Sample(argv);

            // FunCaptcha Sample
            // EndCaptcha.Examples.FunCaptchaSample(argv);

            // HCaptcha Sample
            EndCaptcha.Examples.HCaptchaSample(argv);

            Console.ReadKey();

        }

        static public void PrintRequest(Hashtable request)
        {
            foreach (DictionaryEntry de in request)
            {
                Console.WriteLine("Key = {0}, Value = {1}", de.Key, de.Value);
            }

        }

        static public void TextCaptchaSample(string[] argv){

            string ecUsername = argv[0], ecPassword = argv[1], image = argv[2];

            // Put your EC username & password here.
            Client client = (Client)new HttpClient(ecUsername, ecPassword);

            // Request data container
            Hashtable captcha = new Hashtable();
            string captcha_text = "";

            // Get Balance - (get_balance)
            captcha = client.GetBalance(); //get_balance

            if (captcha.ContainsKey("balance"))
            {
                Console.WriteLine("Your balance is {0:F2} US cents", captcha["balance"]);
            }
            
            // Upload CAPTCHA image - (upload)
            captcha = client.Upload(image); //upload
            PrintRequest(captcha);

            /*
            // Get poll CAPTCHA - (get_captcha)
            captcha = client.GetCaptcha(1843915157);
            PrintRequest(captcha);
            */

            /*
            // Get text CAPTCHA - (get_text)
            captcha_text = client.GetText(970650036);
            Console.WriteLine(captcha_text);
            */


            /*
            // Report CAPTCHA image
            captcha = client.Report(image);
            PrintRequest(captcha);
            */

            /*
            // Report CAPTCHA by captcha_id
            captcha = client.Report("123456789");
            PrintRequest(captcha);
            */

        }

        static public void ReCaptchaV2Sample(string[] argv){

            string ecUsername = argv[0], ecPassword = argv[1];

            // Put your EC username & password here.
            Client client = (Client)new HttpClient(ecUsername, ecPassword);

            // Request data container
            Hashtable captcha = new Hashtable();
            string captcha_text = "";


            // Get Balance - (get_balance)
            captcha = client.GetBalance(); //get_balance

            if (captcha.ContainsKey("balance"))
            {
                Console.WriteLine("Your balance is {0:F2} US cents", captcha["balance"]);
            }

            
            // Decode Token CAPTCHA - (decode)
            captcha = client.Decode(Client.DefaultTokenTimeout,
                        new Hashtable(){
                            { "type", 4 },
                            {
                                "token_params", 
                                    @"{
                                        ""proxy"": """",
                                        ""proxytype"": """",
                                        ""googlekey"": ""6Lc2fhwTAAAAAGatXTzFYfvlQMI2T7B6ji8UVV_f"",
                                        ""pageurl"": ""http://google.com""
                                    }"
                            }

                        });
            PrintRequest(captcha);
            
            /*
            // Upload Token CAPTCHA - (upload)
            captcha = client.Upload(
                        new Hashtable(){
                                        { "type", 4 },
                                        {"token_params", "{\"proxy\": \"http://user:password@127.0.0.1:1234\",\"proxytype\": \"HTTP\",\"googlekey\": \"6Lc2fhwTAAAAAGatXTzFYfvlQMI2T7B6ji8UVV_f\",\"pageurl\": \"http://google.com\"}"}

                        });
            PrintRequest(captcha);
            */

            /*
            // Get poll CAPTCHA - (get_captcha)
            captcha = client.GetCaptcha(1843915157);
            PrintRequest(captcha);
            */

            /*
            // Get text CAPTCHA - (get_text)
            captcha_text = client.GetText(970650036);
            Console.WriteLine(captcha_text);
            */

            /*
            // Report CAPTCHA image
            captcha = client.Report(image);
            PrintRequest(captcha);
            */

            /*
            // Report CAPTCHA by captcha_id
            captcha = client.Report("123456789");
            PrintRequest(captcha);
            */
        }

        static public void ReCaptchaV3Sample(string[] argv){

            string ecUsername = argv[0], ecPassword = argv[1];

            // Put your EC username & password here.
            Client client = (Client)new HttpClient(ecUsername, ecPassword);

            // Request data container
            Hashtable captcha = new Hashtable();
            string captcha_text = "";

            // Get Balance - (get_balance)
            captcha = client.GetBalance(); //get_balance

            if (captcha.ContainsKey("balance"))
            {
                Console.WriteLine("Your balance is {0:F2} US cents", captcha["balance"]);
            }

            
            // Decode Token CAPTCHA - (decode)
            captcha = client.Decode(Client.DefaultTokenTimeout,
                        new Hashtable(){
                            { "type", 5 },
                            {
                                "token_params", 
                                    @"{
                                        ""proxy"": """",
                                        ""proxytype"": """",
                                        ""googlekey"": ""6LdyC2cUAAAAACGuDKpXeDorzUDWXmdqeg-xy696"",
                                        ""pageurl"": ""https://recaptcha-demo.appspot.com/recaptcha-v3-request-scores.php"",
                                        ""action"":  ""examples/v3scores"",
                                        ""min_score"": 0.3
                                    }"
                            }

                        });
            PrintRequest(captcha);
            
            /*
            // Upload Token CAPTCHA - (upload)
            captcha = client.Upload(
                        new Hashtable(){
                            { "type", 5 },
                            {
                                "token_params", 
                                    @"{
                                        ""proxy"": """",
                                        ""proxytype"": """",
                                        ""googlekey"": ""6LdyC2cUAAAAACGuDKpXeDorzUDWXmdqeg-xy696"",
                                        ""pageurl"": ""https://recaptcha-demo.appspot.com/recaptcha-v3-request-scores.php"",
                                        ""action"":  ""examples/v3scores"",
                                        ""min_score"": 0.3
                                    }"
                            }

                        });
            PrintRequest(captcha);
            */

            /*
            // Get poll CAPTCHA - (get_captcha)
            captcha = client.GetCaptcha(1843915157);
            PrintRequest(captcha);
            */

            /*
            // Get text CAPTCHA - (get_text)
            captcha_text = client.GetText(970650036);
            Console.WriteLine(captcha_text);
            */

            /*
            // Report CAPTCHA image
            captcha = client.Report(image);
            PrintRequest(captcha);
            */

            /*
            // Report CAPTCHA by captcha_id
            captcha = client.Report("123456789");
            PrintRequest(captcha);
            */
        }

        static public void FunCaptchaSample(string[] argv){

            string ecUsername = argv[0], ecPassword = argv[1];

            // Put your EC username & password here.
            Client client = (Client)new HttpClient(ecUsername, ecPassword);

            // Request data container
            Hashtable captcha = new Hashtable();
            string captcha_text = "";

            // Get Balance - (get_balance)
            captcha = client.GetBalance(); //get_balance

            if (captcha.ContainsKey("balance"))
            {
                Console.WriteLine("Your balance is {0:F2} US cents", captcha["balance"]);
            }

            
            // Decode Token CAPTCHA - (decode)
            captcha = client.Decode(Client.DefaultTokenTimeout,
                        new Hashtable(){
                            { "type", 6 },
                            {
                                "funcaptcha_params", 
                                    @"{
                                        ""proxy"": """",
                                        ""proxytype"": """",
                                        ""publickey"": ""E8A75615-1CBA-5DFF-8032-D16BCF234E10"",
                                        ""pageurl"": ""https://account.battle.net/creation/flow/creation-full""
                                    }"
                            }

                        });

            PrintRequest(captcha);
            Console.WriteLine("Decode Response: {0}",  HttpUtility.UrlDecode(captcha["text"].ToString()) );
            
            /*
            // Upload Token CAPTCHA - (upload)
            captcha = client.Upload(
                        new Hashtable(){
                            { "type", 6 },
                            {
                                "funcaptcha_params", 
                                    @"{
                                        ""proxy"": """",
                                        ""proxytype"": """",
                                        ""publickey"": ""E8A75615-1CBA-5DFF-8032-D16BCF234E10"",
                                        ""pageurl"": ""https://account.battle.net/creation/flow/creation-full""
                                    }"
                            }

                        });
            PrintRequest(captcha);
            */

            /*
            // Get poll CAPTCHA - (get_captcha)
            captcha = client.GetCaptcha(1843915157);
            PrintRequest(captcha);
            */

            /*
            // Get text CAPTCHA - (get_text)
            captcha_text = client.GetText(970650036);
            Console.WriteLine(captcha_text);
            */

            /*
            // Report CAPTCHA image
            captcha = client.Report(image);
            PrintRequest(captcha);
            */

            /*
            // Report CAPTCHA by captcha_id
            captcha = client.Report("123456789");
            PrintRequest(captcha);
            */
        }

        static public void HCaptchaSample(string[] argv){

            string ecUsername = argv[0], ecPassword = argv[1];

            // Put your EC username & password here.
            Client client = (Client)new HttpClient(ecUsername, ecPassword);

            // Request data container
            Hashtable captcha = new Hashtable();
            string captcha_text = "";

            // Get Balance - (get_balance)
            captcha = client.GetBalance(); //get_balance

            if (captcha.ContainsKey("balance"))
            {
                Console.WriteLine("Your balance is {0:F2} US cents", captcha["balance"]);
            }

            
            // Decode Token CAPTCHA - (decode)
            captcha = client.Decode(Client.DefaultTokenTimeout,
                        new Hashtable(){
                            { "type", 7 },
                            {
                                "hcaptcha_params", 
                                    @"{
                                        ""proxy"": """",
                                        ""proxytype"": """",
                                        ""sitekey"": ""a5f74b19-9e45-40e0-b45d-47ff91b7a6c2"",
                                        ""pageurl"": ""https://accounts.hcaptcha.com/demo""
                                    }"
                            }
                        });

            PrintRequest(captcha);
            
            /*
            // Upload Token CAPTCHA - (upload)
            captcha = client.Upload(
                        new Hashtable(){
                            { "type", 7 },
                            {
                                "hcaptcha_params", 
                                    @"{
                                        ""proxy"": """",
                                        ""proxytype"": """",
                                        ""sitekey"": ""a5f74b19-9e45-40e0-b45d-47ff91b7a6c2"",
                                        ""pageurl"": ""https://accounts.hcaptcha.com/demo""
                                    }"
                            }
                        });
            PrintRequest(captcha);
            */

            /*
            // Get poll CAPTCHA - (get_captcha)
            captcha = client.GetCaptcha(1843915157);
            PrintRequest(captcha);
            */

            /*
            // Get text CAPTCHA - (get_text)
            captcha_text = client.GetText(970650036);
            Console.WriteLine(captcha_text);
            */

            /*
            // Report CAPTCHA image
            captcha = client.Report(image);
            PrintRequest(captcha);
            */

            /*
            // Report CAPTCHA by captcha_id
            captcha = client.Report("123456789");
            PrintRequest(captcha);
            */
        }

    }
}
